<?php
/**
 * @file
 * Provides the hierarchical select access module admin page.
 */

/**
 * Implements hook_form().
 */
function hierarchical_select_access_admin_form($form, &$form_state) {
  $roles = user_roles(TRUE);
  $names = node_type_get_names();
  $form['#tree'] = TRUE;

  $form['roles_fieldset'] = array(
    '#type' => 'fieldset',
    '#title' => t('Settings for all roles'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['roles_fieldset']['roles'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Roles'),
    '#description' => t('Select the roles that should not see the Hierarchical Select widget.'),
    '#default_value' => variable_get('hierarchical_select_access_selected_role', array()),
    '#options' => $roles,
  );

  $form['content_fieldset'] = array(
    '#type' => 'fieldset',
    '#title' => t('Settings for all content types'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['content_fieldset']['content'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Content Types'),
    '#description' => t('Select the content types for which the Hierarchical Select widget will not appear in the node form.'),
    '#default_value' => variable_get('hierarchical_select_access_selected_content', array()),
    '#options' => $names,
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
  );

  return $form;
}

/**
 * Submit callback for setting the form variables.
 */
function hierarchical_select_access_admin_form_submit($form, &$form_state) {
  if (!empty($form_state['values']['roles_fieldset']['roles'])) {
    variable_set('hierarchical_select_access_selected_role', $form_state['values']['roles_fieldset']['roles']);
  }
  if (!empty($form_state['values']['content_fieldset']['content'])) {
    variable_set('hierarchical_select_access_selected_content', $form_state['values']['content_fieldset']['content']);
  }
}
